//+----------------------------------------------------------------------------+
//|                                                                i-BalEq.mq4 |
//|                                                       . aka KimIV |
//|                                                        http://www.kimiv.ru |
//|                                                                            |
//|  01.10.2006     .                                      |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 1

//-------    -------------------------------------------
//-------    -----------------------------------------
extern double Deposit       = 3000;    //  
extern bool   CurSymbolOnly = False;   //    

//-------   ----------------------------------------------------
double dBuf0[], dBuf1[];

//-------    -------------------------------------
int    oob[];      //   
int    oty[];      // 
double olo[];      // 
string osy[];      // 
double oop[];      //  
int    ocb[];      //   
double ocp[];      //  
double osw[];      // 
double opr[];      // 


//+----------------------------------------------------------------------------+
//| Custom indicator initialization function                                   |
//+----------------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, dBuf0);
  SetIndexLabel (0, "Balance");
  SetIndexStyle (0, DRAW_LINE);

  SetIndexBuffer(1, dBuf1);
  SetIndexLabel (1, "Equity");
  SetIndexStyle (1, DRAW_LINE);
}

//+----------------------------------------------------------------------------+
//| Custom indicator iteration function                                        |
//+----------------------------------------------------------------------------+
void start() {
  double b, e, p;
  int    i, j, k;

  ReadDeals();
 	if (oob[0]<0) return;
 	k=ArraySize(oob);

  for (i=oob[0]; i>=0; i--) {
    b=Deposit; e=0;
    for (j=0; j<k; j++) {
      if (i<=oob[j] && i>ocb[j]) {
        p=MarketInfo(osy[j], MODE_POINT);
        if (oty[j]==OP_BUY) e+=(iClose(osy[j], 0, i)-ocp[j])/p;
        else e+=(ocp[j]-iClose(osy[j], 0, i))/p;
      } else if (i<=ocb[j]) b+=osw[j]+opr[j];
    }
    dBuf0[i]=b;
    dBuf1[i]=b+e;
  }
}

//+----------------------------------------------------------------------------+
//|                                                                |
//+----------------------------------------------------------------------------+
void ReadDeals() {
  ArrayResize(oob, 0);
  ArrayResize(oty, 0);
  ArrayResize(olo, 0);
  ArrayResize(osy, 0);
  ArrayResize(oop, 0);
  ArrayResize(ocb, 0);
  ArrayResize(ocp, 0);
  ArrayResize(osw, 0);
  ArrayResize(opr, 0);
  int h=HistoryTotal(), i, k;

  for (i=0; i<h; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (!CurSymbolOnly || OrderSymbol()==Symbol()) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          k=ArraySize(oob);
          ArrayResize(oob, k+1);
          ArrayResize(oty, k+1);
          ArrayResize(olo, k+1);
          ArrayResize(osy, k+1);
          ArrayResize(oop, k+1);
          ArrayResize(ocb, k+1);
          ArrayResize(ocp, k+1);
          ArrayResize(osw, k+1);
          ArrayResize(opr, k+1);
          oob[k]=iBarShift(NULL, 0, OrderOpenTime()); //   
          oty[k]=OrderType();                         // 
          olo[k]=OrderLots();                         // 
          osy[k]=OrderSymbol();                       // 
          oop[k]=OrderOpenPrice();                    //  
          ocb[k]=iBarShift(NULL, 0, OrderCloseTime());//   
          ocp[k]=OrderClosePrice();                   //  
          osw[k]=OrderSwap();                         // 
          opr[k]=OrderProfit();                       // 
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+

